/*
  XFLib - XF management library

  (C) Max Volkov, Sevastopol 2006-2008
  Mailto: max at xfhome dot org
*/

#include "xf.h"
#include "hash.h"

#ifdef __cplusplus
extern "C" {
#endif

_XF_API xfInt xfStart();
_XF_API xfVoid xfStop();

_XF_API xfInt xfVersion();
_XF_API xfChar* xfInfo();

_XF_API xfVoid xfSetMemManager(xfUserAlloc_t alloc,xfUserFree_t free);
_XF_API xfVoid xfResetMemManager();

_XF_API xfInt xfLoadMsgList(xfNChar *filename);
_XF_API xfInt xfLoadMsgListString(xfChar *string);
_XF_API xfChar* xfTranslateMsg(xfChar *msg);

_XF_API xfSecurity* xfCreateSecurity();
_XF_API xfVoid xfDestroySecurity(xfSecurity *security);
_XF_API xfInt xfGetDocNodeNum(xfMap *map);
_XF_API xfSecurity* xfGetDocSecurity(xfMap *map);
_XF_API xfSecurity* xfSetDocSecurity(xfMap *map,xfSecurity *security);
_XF_API xfVoid xfResetDocSecurity(xfMap *map);
_XF_API xfInt xfSecurityGetNodeLimit(xfSecurity *security);
_XF_API xfVoid xfSecuritySetNodeLimit(xfSecurity *security,xfInt nodeLimit);
_XF_API xfInt xfSecurityGetDocSize(xfSecurity *security);
_XF_API xfVoid xfSecuritySetDocSize(xfSecurity *security,xfInt docSize);
_XF_API xfInt xfCanAddNode(xfMap *map);

_XF_API xfInt xfBigEndian();
_XF_API xfInt xfLittleEndian();

_XF_API xfNChar* xfConvertToASCII(xfChar *src,xfNChar *dst);
_XF_API xfChar* xfConvertFromASCII(xfNChar *src,xfChar *dst);
_XF_API xfNChar* xfConvertToUTF8(xfChar *src,xfNChar *dst);
_XF_API xfChar* xfConvertFromUTF8(xfNChar *src,xfChar *dst);
_XF_API xfChar xfCharByteSwap(xfChar c);

_XF_API xfMap* xfCreate();
_XF_API xfVoid xfDestroy(xfMap *map);

_XF_API xfInt xfGetDocNodeNum(xfMap *map);

_XF_API xfChar* xfGetError(xfMap *map);
_XF_API xfChar* xfSetError(xfMap *map,xfChar *error);

_XF_API xfInt xfGetErrorLine(xfMap *map);
_XF_API xfInt xfSetErrorLine(xfMap *map,xfInt lineno);
_XF_API xfInt xfGetErrorCol(xfMap *map);
_XF_API xfInt xfSetErrorCol(xfMap *map,xfInt colno);

_XF_API xfNode* xfEnter(xfNode *parent,xfChar *name);
_XF_API xfNode* xfEnterPath(xfNode *node,xfChar *path);
_XF_API xfNode* xfParent(xfNode *node);
_XF_API xfNode* xfChild(xfNode *node);
_XF_API xfNode* xfLastChild(xfNode *node);
_XF_API xfNode* xfNext(xfNode *node);
_XF_API xfNode* xfPrev(xfNode *node);
_XF_API xfChar* xfName(xfNode *node);
_XF_API xfInt xfIsRoot(xfNode *node);
_XF_API xfInt xfNumChildren(xfNode *node);

_XF_API xfChar* xfGet(xfNode *node);
_XF_API xfChar* xfGetClass(xfNode *node);

_XF_API xfNode* xfAdd(xfNode *parent,xfChar *name,xfChar *value,xfChar *Class);
_XF_API xfNode* xfAddPath(xfNode *node,xfChar *path);
_XF_API xfVoid xfRemove(xfNode *node);
_XF_API xfVoid xfClear(xfNode *node);

_XF_API xfChar* xfSet(xfNode *node,xfChar *value);
_XF_API xfChar* xfSetClass(xfNode *node,xfChar *Class);

_XF_API xfChar* xfGetPathValue(xfNode *node,xfChar *path);
_XF_API xfChar* xfSetPathValue(xfNode *node,xfChar *path,xfChar *value);
_XF_API xfChar* xfGetPathClass(xfNode *node,xfChar *path);
_XF_API xfChar* xfSetPathClass(xfNode *node,xfChar *path,xfChar *Class);

_XF_API xfChar* xfGetDocVersion(xfMap *map);
_XF_API xfChar* xfSetDocVersion(xfMap *map,xfChar *value);
_XF_API xfChar* xfGetDocClass(xfMap *map);
_XF_API xfChar* xfSetDocClass(xfMap *map,xfChar *value);
_XF_API xfChar* xfGetDocComment(xfMap *map);
_XF_API xfChar* xfSetDocComment(xfMap *map,xfChar *value);
_XF_API xfChar* xfGetDocHeader(xfMap *map);
_XF_API xfChar* xfSetDocHeader(xfMap *map,xfChar *header);
_XF_API xfInt xfGetDocEncoding(xfMap *map);
_XF_API xfVoid xfSetDocEncoding(xfMap *map,xfInt encoding);

_XF_API xfVoid xfOptionAddInfo(xfMap *map,xfInt option);
_XF_API xfVoid xfOptionAddComment(xfMap *map,xfInt option);
_XF_API xfVoid xfOptionCharCodes(xfMap *map,xfInt option);

_XF_API xfIterator* xfCreateIterator();
_XF_API xfVoid xfDestroyIterator(xfIterator *iterator);
_XF_API xfVoid xfSetIteration(xfIterator *iterator,xfNode *node,xfInt recursive);
_XF_API xfNode* xfNextIteration(xfIterator *iterator);
_XF_API xfInt xfIterationCounter(xfIterator *iterator);
_XF_API xfInt xfIterationLevel(xfIterator *iterator);

_XF_API xfChar* xfStrchr(xfChar *s,xfInt c);
_XF_API xfInt xfStrlen(xfChar *s);
_XF_API xfChar* xfStrcpy(xfChar *dst,xfChar *src);
_XF_API xfInt xfStrcmp(xfChar *s1,xfChar *s2);
_XF_API xfChar* xfStrstr(xfChar *s1,xfChar *s2);
_XF_API xfChar* xfStrdup(xfChar *s);

_XF_API xfNChar* xfNStrchr(xfNChar *s,xfInt c);
_XF_API xfInt xfNStrlen(xfNChar *s);
_XF_API xfNChar* xfNStrcpy(xfNChar *dst,xfNChar *src);
_XF_API xfInt xfNStrcmp(xfNChar *s1,xfNChar *s2);
_XF_API xfNChar* xfNStrstr(xfNChar *s1,xfNChar *s2);
_XF_API xfNChar* xfNStrdup(xfNChar *s);

_XF_API xfVoid* xfAlloc(xfInt size);
_XF_API xfVoid xfFree(xfVoid *p);

_XF_API xfInt xfReadFile(xfMap *map, xfNChar *fileName);
_XF_API xfInt xfReadString(xfMap *map, xfChar *string);

_XF_API xfInt xfWriteFile(xfMap *map, xfNChar *fileName);
_XF_API xfInt xfWriteString(xfMap *map, xfChar *string, xfInt maxSize);

_XF_API xfChar* xfIntToDec(xfInt n,xfChar *str);
_XF_API xfChar* xfIntToHex(xfInt n,xfChar *str);
_XF_API xfInt xfDecToInt(xfChar *str);
_XF_API xfInt xfHexToInt(xfChar *str);

_XF_API xfHash* xfCreateHash(xfInt hashSize);
_XF_API xfVoid xfDestroyHash(xfHash *hash);
_XF_API xfHash* xfResizeHash(xfHash *hash,xfInt hashSize);
_XF_API xfHash* xfHashAdd(xfHash *hash,xfVoid *key,xfInt keySize,xfVoid *data,xfInt dataSize,xfInt attr);
_XF_API xfHash* xfHashRemove(xfHash *hash,xfVoid *key,xfInt keySize);
_XF_API xfVoid* xfHashFind(xfHash *hash,xfVoid *key,xfInt keySize,xfInt *dataSize);

#ifdef __cplusplus
}
#endif


