/*
  XFLib - XF management library

  (C) Max Volkov, Sevastopol 2006-2008
  Mailto: max at xfhome dot org
*/

/*
  Initialization routines
*/

#include "xf.h"
#include "xf_api.h"
#include "xf_sys.h"

xfChar xfTitle[] = XF_TITLE;

_XF_API xfInt
xfStart()
{
 xfLoadMsgListString(xfMsgListString);

 return XFE_OK;
}

_XF_API xfVoid
xfStop()
{
}

_XF_API xfMap*
xfCreate()
{
 xfMap *m;
 xfNode *root;

 m = (xfMap*)xfAlloc(sizeof(xfMap));
 if (!m) return XF_NULL;

 m->magic = XF_MAP_MAGIC;
 m->error = XF_NULL;
 m->lineno = XF_NULL;
 m->colno = XF_NULL;
 m->header = XF_NULL;

 m->security = XF_NULL;
 m->nodeNum = XF_NULL;

 /* Document genaration options */
 m->o_encoding = XF_ENC_UTF8;
 m->o_addInfo = true;
 m->o_addComment = true;
 m->o_charCodes = false;

 /* Create root node */
 root = xfAllocNode();
 if (!root)
  {
   xfFree(m);
   return XF_NULL;
  }

 /* Fill the root */
 root = root;
 root->map = m;
 root->parent = root->next = root->prev = XF_NULL;
 root->name = root->Class = root->value = XF_NULL;
 /* The only two fields we use in the root node */
 root->firstChild = root->lastChild = XF_NULL;
 root->numChildren = XF_NULL;
 root->hash = XF_NULL;

 m->root = root;

 return m;
}

_XF_API xfVoid
xfDestroy(xfMap *map)
{
 xfRemove(map->root);
 if (map->header) xfFree(map->header);
 if (map->error) xfFree(map->error);
 if (map) xfFree(map);
}

_XF_API xfInt
xfVersion()
{
 return XFLIB;
}

_XF_API xfChar*
xfInfo()
{
 return xfTitle;
}


