#include <stdio.h>
#include <string.h>

#include "simtest/src/simtest.h"

#include "../../lib/xf.h"
#include "../../lib/xf_api.h"

#define OPS 1
#define FILENAME "test.xf"

char *data;
xfChar *data2;

void st_start()
{
 FILE *file;
 int c,size = 0;

 data = malloc(16*1024*1024);
 if (!data) st_crash("not enough memory");

 data2 = malloc(16*1024*1024 * 2);
 if (!data2) st_crash("not enough memory");

 file = fopen(FILENAME,"r");
 if (!file) st_crash("cannot open file");

 c = '!';
 while (1)
  {
   c = fgetc(file);
   if (c == EOF) break;
   data[size] = c;
   size++;
  }

 data[size] = 0;

 xfConvertFromASCII(data,data2);

 st_ops = xfStrlen(data2) * 2 * OPS;
 st_name = "XFLib: parse unicode document from memory (bytes/sec)";

 st_tests = 3;
 st_repeats = 1;

 xfStart();

 fclose(file);
}

void st_stop()
{
 xfStop();
 free(data);
}

void st_test()
{
 int i,r;
 xfMap *m;
 xfChar str[100];

 for (i = 0; i < OPS; i++)
  {
   m = xfCreate();
   r = xfReadString(m,data2);
   if (r)
    {
     sprintf(str,"parse error line %i col. %i: %S",xfGetErrorLine(m),
             xfGetErrorCol(m),xfGetError(m));
     st_crash(str);
    }
   xfDestroy(m);
  }
}

