/*
  SimTest - Simple Benchmark Library
  (C) Max Volkov (xfsoft@mail.ru), Sevastopol 2006
*/

#ifndef _SIMTEST_H_
#define _SIMTEST_H_

#define XFSOFT

/* Version info */
#define ST_VN   0
#define ST_SN   1

/* Default number of tests and number of
   repeats for each test */
#define ST_TESTS        3
#define ST_REPEATS      10000

#ifdef __GNUC__
#define CLK_TCK 1000000
#endif

typedef int st_int;
typedef float st_float;

extern int st_tests, st_repeats;

extern void st_start();
extern void st_stop();
extern void st_test();

/* Should be set by st_start() / st_test */
extern int st_error;    /* Non zero if testing failed */
extern int st_ops;      /* Operations per 1 st_test() call */
extern char *st_name;   /* Symbolic name of test */

void st_crash(char *msg);
void st_init();
int st_work(int tests,int repeats);
void st_log(st_float avgtime,st_float mintime,st_float maxtime,int tests,
            int repeats,int ops);

extern st_float st_tick;  /* Numbers of SimTest ticks per second (e.g. 1000) */


#endif

