/*
  XFLib sample code
  Create new XF document
*/

#include <stdio.h>
#include <stdlib.h>

#include "./../../lib/xf.h"
#include "./../../lib/xf_api.h"

int main(int argc,char *argv[])
{
 xfMap *doc;
 xfNode *root,*s;
 xfInt i,n;
 xfNChar a[100];
 xfChar aa[100],r[20];

 xfStart();

 doc = xfCreate();

 xfSetDocVersion(doc,XF);
 xfSetDocClass(doc,L"XFHome.XFLib.Sample.Newdoc");
 xfSetDocHeader(doc,L"This is a comment\nIt will be added to your XF document");

 root = xfAddPath(doc->root,L"document");

 n = 0;
 if (argv[1]) n = atoi(argv[1]);
 if (!n) n = 100;

 for (i = 0; i < n; i++)
  {
   sprintf(a,"section-%i",i);
   xfConvertFromASCII(a,aa);

   s = xfAddPath(root,aa);

   xfAdd(s,L"title",L"Wow!!!",L"string");
   xfAdd(s,L"text",L"Some text comes here=)",L"string");
   xfAdd(s,L"number",xfIntToDec(rand(),r),L"int");
  }

 /* Write file in different encodings */
 xfSetDocEncoding(doc,XF_ENC_ASCII); xfWriteFile(doc,"new_doc.xf");
 xfSetDocEncoding(doc,XF_ENC_UTF8);  xfWriteFile(doc,"new_doc_utf8.xf");
 xfSetDocEncoding(doc,XF_ENC_UTF16); xfWriteFile(doc,"new_doc_utf16.xf");

 xfDestroy(doc);

 xfStop();

 return 0;
}

