/*
  XFLib sample
  View XF document scheme (print elements as tree)
*/

#include <stdio.h>

#include "./../../lib/xf.h"
#include "./../../lib/xf_api.h"

int main(int argc,char *argv[])
{
 xfMap *map;
 xfIterator *i;
 xfNode *n;
 int r,c;

 if (argc < 2)
  {
   printf("View XF document scheme\n");
   printf("Usage: scheme filename\n");
   return 1;
  }

 xfStart();
 map = xfCreate();
 r = xfReadFile(map,argv[1]);
 if (r) {
   printf("scheme: error processing document\n");
   if (r == XFE_IO) printf("cannot open document\n");
   if (r == XFE_FORMAT) {
     printf("parse error (line %i col %i): %S\n",
            xfGetErrorLine(map),xfGetErrorCol(map),xfGetError(map));
    }
   return 1;
  }

 i = xfCreateIterator();
 xfSetIteration(i,map->root,1);
 while (n = xfNextIteration(i)) {
   for (c = 0; c < xfIterationLevel(i); c++) printf("   ");
   printf("%S",xfName(n));
   if (xfGetClass(n)) printf(":%S",xfGetClass(n));
   if (xfGet(n)) printf(" = %S",xfGet(n));
   printf("\n");
  }
 xfDestroyIterator(i);

 xfDestroy(map);
 xfStop();
 return 0;
}

