/*
  XFLib sample code
  Process electronic pricelist
*/

#include <stdio.h>
#include <stdlib.h>

#include "../../lib/xf.h"
#include "../../lib/xf_api.h"
#include "../../lib/xf_sys.h"

xfMap *List;

int main(int argc,char *argv[])
{
 int i;
 xfChar *type,*vendor,*model,*price,*currency,str[100];
 xfNode *ptr,*product;

 xfStart();

 List = xfCreate();
 if (xfReadFile(List,"pricelist.xf"))
  { printf("Error parsing file (line %i col %i): %S\n",
           xfGetErrorLine(List),xfGetErrorCol(List),xfGetError(List)); return 1; }

 xfWriteFile(List,"a.xf");

 if (argc < 2)
  {
   printf("Usage: shop [product-name]\nProduct list:\n");

   ptr = xfEnterPath(List->root,L"pricelist");
   if (!ptr) exit(0);
   ptr = xfChild(ptr);
   printf("- %S\n",xfName(ptr));

   while (1)
    {
     ptr = xfNext(ptr);
     if (!ptr) break;
     printf("- %S\n",xfName(ptr));
    }

   exit(0);
  }

 ptr = xfEnter(List->root,L"pricelist");
 ptr = xfEnter(ptr,xfConvertFromASCII(argv[1],str));
 if (!ptr) { printf("SHOP: Unknown product\n"); exit(1); }

 type =     xfGet(xfEnter(ptr,L"type"));
 vendor =   xfGet(xfEnter(ptr,L"vendor"));
 model =    xfGet(xfEnter(ptr,L"model"));

 ptr = xfEnter(ptr,L"price");
 price =    xfGet(xfEnter(ptr,L"value"));
 currency = xfGet(xfEnter(ptr,L"currency"));

 printf("*** %s *** (%S)\n",argv[1],type);

 printf("%S %S (%S %S)\n",vendor,model,price,currency);

 xfDestroy(List);

 xfStop();

 return 0;
}

