#include <stdio.h>
#include <stdlib.h>

#include "../../lib/xf.h"
#include "../../lib/xf_api.h"

int getint(xfMap *doc,xfChar *path)
{
 return xfDecToInt(xfGet(xfEnterPath(doc->root,path)));
}

int main(int argc, char* argv[])
{
 xfMap *conf;
 int r;
 FILE *h;

 xfStart();

 if (argc != 2) {
   printf("xflib_conf\n");
   printf("usage: xflib_conf filename\n");
   exit(1);
  }

 conf = xfCreate();

 r = xfReadFile(conf,argv[1]);
 if (r) {
   if (r == XFE_IO) printf("xflib_conf: cannot open file '%s'\n",argv[1]);
   if (r == XFE_MEMORY) printf("xflib_conf: not enough memory\n",argv[1]);
   if (r == XFE_FORMAT) {
     printf("xflib_conf: error parsing file '%s': %S (line %i col %i)\n",
            argv[1],xfGetError(conf),xfGetErrorLine(conf),xfGetErrorCol(conf));
    }
   xfDestroy(conf);
   exit(1);
  }

 h = fopen("xf_conf.h","wt");
 if (!h) {
   printf("xflib_conf: cannot create file 'xf_conf.h'\n");
   xfDestroy(conf);
   exit(2);
  }

 fprintf(h,"/*\n  Generated by XFLib_Conf\n  XFLib configuration file\n");
 fprintf(h,"  XFLib version: %S\n*/\n\n",xfInfo());
 fprintf(h,"#define XF_NODESIZE %i\n",getint(conf,L"Conf NodeSize"));
 fprintf(h,"#define XF_STACKSIZE %i\n",getint(conf,L"Conf StackSize"));
 fprintf(h,"#define XF_HASH_SIZE %i\n",getint(conf,L"Conf Hash Size"));
 fprintf(h,"#define XF_HASH_NODE_SIZE %i\n",getint(conf,L"Conf Hash CreateLevel"));
 fprintf(h,"#define XF_AUTOHASH %i\n",getint(conf,L"Conf Hash AutoResizeLevel"));
 fprintf(h,"\n");

 fclose(h);

 printf("created 'xf_conf.h'\n");

 xfDestroy(conf);

 xfStop();

 return 0;
}

