#ifndef CLIENTDATARECERVER_H_
#define CLIENTDATARECERVER_H_
#include "BaseConfigFile.h"
#include "ServerConfig.h"
#include <map>
#include <list>
#include <vector>
#include <string>
#include "XML/Server.h"
//Модуль обработки запросов между сервером и клиентом
//Он вызывает опердиленные модули для обработки каждой из пришедших станз, для сервера модули будут выполнять 
//Действия над файлами, для клиента операции над ФС через Fuse

typedef void* funcGetData(int datacount);
typedef void funcSendData(void* data, int datacount);
//Указатель такого типа обрабатывает вызовы всех станз, модуль сам должен их заполнить в список и после прихода станзы
//вызывается каждый раз последовательно до тех пор пока не будет возвращено значение true
typedef bool moduleFunc(void* stanza, funcSendData *sendd,funcGetData *getd);
typedef list<moduleFunc*> moduleFuncListType;
//Тип вызывается при нахождении файла
typedef void findedFileT(char * filename);
//Функция расширений принимает данные профодит их через расширение передает дальше.
//typedef extendFunc(datain char* );
//Расширения
struct ExtendInfo{
	int number;//Порядковый номер расширения, в последовательности как они обрабатываются
	
};
class ClientServerDataTransfer;
//Структура передается в каждый поток где обрабатывается каждый подключеный клиент
struct ThreadStruct{
	ClientServerDataTransfer* self;//Сам класс внутри которого преедача данных
	int clientSocket;//Сокет через который конкретный клиент будет совершать подключения
	unsigned int clientIP; //IP адрес клиента с которым в данный момент соединены
};

class ClientServerDataTransfer{
protected:
   //Расширения которыеидут поверх протокола
        //Название расширения
    //map<String name, >
//    map<String stanza,moduleFunc*> moduleFuncMap;
   //Список функций обрабатывающих станзы
    moduleFuncListType moduleFuncList;
    //Конфигурационный файл сервера, он же будет передаваться во все расширения чтобы они могли прочесть необходимые им данные из конфигурационнного файла
    ServerConfig* conf;
    void findModules(){};//Поиск модулей
    void findExtends(){};//поиск расширений
    //Метод для поиска файлов и добавления их в списки модулей и в списки расширений
    void findFiles(char* path, findedFileT * file);
    //Список экземпляров протокола для клиентов подключенных к серверу
    list <Server*/*<ClientServerDataTransfer>*/> connectionList;
public:
    //Выполняет поиск модулей и регистрирует вызовы их для обработки станз, ожидает подключение клиентов.
    //Модули передают в класс указатель на функцию, которая обрабатывает станзу, ей передается станза и 
    //2 метода один для чтения данных жругой для записи ответов, 
    //и она возвращает логическое значение принимает ли модуль данную станзу. 
    //В которую передается, если не принимает то производится поиск следующего модуля.
    //Так же тут должны быть расширения такие как методы, аутентификации, сжатия, шифрования.    
	ClientServerDataTransfer(ServerConfig& c);
	void waiteClentConnections();//Метод который ожидает подключения клиентов
	//Выполняет последовательно чтение целой станзы и вызывает каждый модуль до тех пор,
	// пока станза не будет отвергнута всеми, либо не найдется такой модуль который ее примет
	void recevedStanza(Node* stanza);
	void moduleProcess();
	virtual ~ClientServerDataTransfer();
};

#endif /*CLIENTDATARECERVER_H_*/
