/*
 * Node.cpp
 *
 *  Created on: 08.04.2011
 *      Author: nick
 */

#include "Node.h"
#include <iostream>
//Маразматическая замена подстроки в строке, блин...
void replace(std::string& text, std::string s, std::string d){
  for (int index=text.find(s, 0); index!=-1; index=text.find(s, index) ) {
    text.replace(index, s.length(), d);
    index+=d.length();
  }
}

string XMLescape(string txt){
	replace(txt,"&","&amp;");
	replace(txt,">", "&gt;");
	replace(txt,"\"", "&quot;");
	replace(txt,"\x0C", "");
	replace(txt,"\x1B", "");
	return txt;
}

Node::Node(string name,  Node* parent,string xmlns) {
	//isDuplicate=false;
	this->name=name;
	this->parent=parent;
	if(xmlns!=""){
		attrs["xmlns"]=xmlns;
	}
	if (parent){
		parent->addChild(this);
	}
}

Node::Node(string name, map <string, string> &attrs,  Node* parent=NULL) {
	// TODO Auto-generated constructor stub
	//isDuplicate=false;
	this->name=name;
	this->parent=parent;
	this->attrs=attrs;
	if (parent){
		parent->addChild(this);
	}
}

void Node::addChild(Node* child){
	child->parent=this;
	kinds.push_back(child);
}

void Node::setNamespace(string xmlns){
	attrs["xmlns"]=xmlns;
}

string Node::toXMLStringStart(){
	string res="";
	res+="<"+XMLescape(name);
	map <string, string> ::iterator it=attrs.begin();
	while (it!=attrs.end()){
		res+=" "+XMLescape((*it).first)+"=\""+XMLescape((*it).second)+"\"";
		it++;
	}
	res+=">\n";
	return res;
}

string Node::toXMLStringEnd(){
	return "</"+name+">\n";
}

string Node::toXMLString(){
	string res="";
	cout<<"-1-"<<endl;
	res+="<"+XMLescape(name);
	cout<<"-2-"<<endl;
	map <string, string> ::iterator it=attrs.begin();
	cout<<"-3-"<<endl;
	while (it!=attrs.end()){
		cout<<"-4-"<<endl;
		res+=" "+XMLescape((*it).first)+"=\""+XMLescape((*it).second)+"\"";
		it++;
	}
	cout<<"-5-"<<endl;
	if ((kinds.begin()==kinds.end())&&(xmlBody.length()==0)){
		res+="/>\n";
	}else{
		res+=">";
		if (kinds.begin()==kinds.end()){
			res+=XMLescape(xmlBody);
		}else{
			res+="\n";
			list<Node*>::iterator p=kinds.begin();
			while (p!=kinds.end()){
				res+=(*p)->toXMLString();
				p++;
			}
		}
		res+="</"+name+">\n";
	}
	cout<<"-6OK-"<<endl;
	return res;
}


void Node::copyKinds(const Node &basedNode){
	cout<<"copy KINDS NODE!"<<endl;
	cout<<"============= copy: ============= :"<<basedNode.name<<endl;
	//isDuplicate=true;
	this->name=basedNode.name;
	list<Node*>::const_iterator it=basedNode.kinds.begin();
	//this->kinds=basedNode->kinds;//
	//Первая нода должна ссылаться на тот парент от которого была создана дублируемая
	this->parent=basedNode.parent;
	this->attrs=basedNode.attrs;
	this->xmlBody=basedNode.xmlBody;
	while (it!=basedNode.kinds.end()){
		Node* n=new Node(*(*it));
		//А ноды дети должны ссылаться на себя, и здесь мы ссылку перепишим
		n->parent=this;
		cout<<"============= addKinds: ============= :"<<n->name<<endl;
		this->kinds.push_back(n);
		cout<<"ka "<<n->name<<endl;
		++it;
	}
	cout<<"============= copyed: ============= :"<<basedNode.name<<endl;
}
//Мда, но в киндсах останется тот класс который и был, раньше, а не станза, в нод...
Node::Node(const Node &basedNode){
	copyKinds(basedNode);
}

Node* Node::getKind(string xmlns){
	list<Node*>::iterator it=kinds.begin();
	while (it!=kinds.end()){
		if ((*it)->getNamesapace()==xmlns){
			return *it;
		}
		++it;
	}
	return NULL;
}

_Kinds_iterator Node::kindsNameBegin(string name){
	_Kinds_iterator ki;
	ki.beginitem=kinds.begin();
	ki.enditem=kinds.end();
	ki.curitem=kinds.begin();
	ki.name=name;
	if ((*ki.curitem)->name!=name){
		++ki;
	}
	return ki;
}

_Kinds_iterator Node::kindsNameEnd(string name){
	_Kinds_iterator ki;
	ki.beginitem=kinds.begin();
	ki.enditem=kinds.end();
	ki.curitem=kinds.end();
	ki.name=name;
	return ki;
}

void Node::destroyKinds(){
	// TODO Auto-generated destructor stub
	//list<Node*>::iterator p=kinds.begin();
	/*while ((p!=kinds.end())&&(!isDuplicate)){
		delete (*p);
		p++;
	}*/
	cout<<"-Node1-"<<endl;
	//cout<<"XML "<<this->toXMLString();
	cout<<name<<endl;
	cout<<"-Node2-"<<endl;
	while /*(*/(kinds.begin()!=kinds.end())/*&&(!isDuplicate))*/{
		delete (*kinds.begin());
		//Node* nd=kinds.pop_back();
		//delete nd;
			//p++;
	}
	cout<<"-Node3-"<<endl;
	if(parent!=NULL){
		this->parent->removeKind(this);
	}
	cout<<"=============destroyed ===========: "<<name<<endl;
/*	if((!isDuplicate)&&(parent!=NULL)){
		cout<<"delete parent:"<<parent->name<<" "<<this->name<<endl;
		this->parent->removeKind(this);
	}*/
	//kinds.clear();
}

Node &Node::operator=(Node &obj){
	destroyKinds();
	copyKinds(obj);
	return *this;
}

void Node::setXMLBody(long body){
	stringstream res;
	res<<body;
	xmlBody=res.str();
}

long Node::getXMLBodyInt(){
	istringstream res(xmlBody);
	long r=0;
	res>>r;
	return r;
}

Node::~Node() {
	destroyKinds();
}
