/*
 * Node.h
 *
 *  Created on: 08.04.2011
 *      Author: nick
 */

#ifndef NODE_H_
#define NODE_H_
#include <map>
#include <list>
#include <map>
#include <string>
#include <sstream>
using namespace std;
string XMLescape(string txt);
struct _Kinds_iterator;

class Node {
protected:
	//Имя узла
	string name;
	//Атрибуты узла - ключь, значение
	map <string, string> attrs;
	Node* parent;
	string xmlBody;
	//Потомки узла
	list <Node*> kinds;
	void destroyKinds();
	virtual void copyKinds(const Node &basedNode);
	//bool isDuplicate;
public:
	//Конструктор, создает элемент ноды
	//parent-Указатель на родительскую ноду
	//name- имя станзы
	//attrs-атрибуты ноды
	Node(string name, map <string, string> &attrs,  Node* parent);
	Node(string name,  Node* parent=NULL,string xmlns="");
	list <Node*>::iterator firstChild(){return kinds.begin();}
	list <Node*>::iterator endChild(){return kinds.end();}
	//Возвращает имя узла
	string getName(){return name;}
	//Возвращает предка узла
	Node* getParent(){return parent;}
	void setName(string n){name=n; };
	void setNamespace(string xmlns);
	void setAttribute(string name, string value){attrs[name]=value;};
	string getAttribute(string name){return attrs[name];};
	string getNamesapace() {return attrs["xmlns"];};
	void removeKind(Node* node){kinds.remove(node);}
	string toXMLString();
	string toXMLStringStart();
	string toXMLStringEnd();
	void setXMLBody(string body){xmlBody=body;};
	void setXMLBody(long body);
	string getXMLBody(){return xmlBody;};
	long getXMLBodyInt();
	Node* getKind(string xmlns);
	//Добавляет в узел потомка
	virtual void addChild(Node* child);
	Node(const Node &baseNode);
	_Kinds_iterator kindsNameBegin(string name);
	_Kinds_iterator kindsNameEnd(string name);
	virtual ~Node();
	friend class Stanza;
	friend class TagIQ;
	typedef _Kinds_iterator nameiterator;
	Node &operator=(Node &obj);
};

class _Kinds_iterator{
private:
	list<Node*>::iterator curitem;
	list<Node*>::iterator beginitem;
	list<Node*>::iterator enditem;
	string name;
public:
	_Kinds_iterator &operator++()
    {
    	do{
    		++curitem;
    	}while ((curitem!=enditem)&&((*curitem)->getName()!=name));
    	return (*this);
    }

	_Kinds_iterator operator++(int)
    {
		_Kinds_iterator temp=*this;
    	do{
    		++curitem;
    	}while ((curitem!=enditem)&&((*curitem)->getName()!=name));
    	return temp;
    }

	bool operator==(_Kinds_iterator &i1){
		return this->curitem==i1.curitem;
	}

	bool operator!=(_Kinds_iterator &i1){
		return !(*this==i1);
	}
    Node* operator*() const
    { return (*curitem); }
    friend class Node;
};

#endif /* NODE_H_ */
