/*
 * Protocol.h
 *
 *  Created on: 09.04.2011
 *      Author: nick
 */

#ifndef PROTOCOL_H_
#define PROTOCOL_H_

#include "Node.h"
#include <string>
#include <map>
#include "TagHandler.h"
#include "TagIQ.h"
#include <expat.h>
#include <iostream>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/sem.h>
#include <string.h>

#define BUFFSIZE        8192
using namespace std;
//template <class Listener_T>
//template <class Listener_T> class Protocol;
//typedef void (Protocol<Listener_T>::*packetRecerver)(Node*);

/*template  <class Listener_T>*/
typedef multimap<pair<string,string>, TagHandler<Node>::PTagHandler> TagHandelrsMapT;
						//subtag //sub-xmlns
typedef multimap<pair<string,string>, TagHandler<TagIQ>::PTagHandler> IQHandelrsMapT;

struct IQRespDKey{
	string xmlns;
	string subtagName;
	string id;
	bool operator<(const IQRespDKey &obj2) const;
	/*bool operator==(const IQRespDKey &obj2) const;
	bool operator!=(const IQRespDKey &obj2) const;*/
	//friend bool operator<(const IQRespDKey &obj1,const IQRespDKey &obj2);

};
/*	bool operator<(const IQRespDKey &obj){
		return (this->id<obj.id) && (this->subtagName<obj.subtagName) &&
				(this->xmlns<obj.xmlns);
	}*/
/*	bool operator==(const IQRespDKey& obj){
		return (this->id==obj.id) && (this->subtagName==obj.subtagName) &&
				(this->xmlns==obj.xmlns);
	}

	bool operator>(const IQRespDKey& obj){
		return (this->id>obj.id) && (this->subtagName>obj.subtagName) &&
				(this->xmlns>obj.xmlns);
	}

	bool operator<=(const IQRespDKey& obj){
		return !(*this>obj);
	}

	bool operator!=(const IQRespDKey& obj){
		return !(*this==obj);
	}

	bool operator<(const IQRespDKey& obj){
		return (!(*this>obj))&&(!(*this==obj));
	}

	bool operator>=(const IQRespDKey& obj){
		return (*this>obj)||(*this==obj);
	}*/
//};

struct IQRespD{
	TagIQ result;
	int semID;
	~IQRespD();
};

class Protocol/*:public TagHandler<Node>*/ {
public:
	//typedef void (Listener_T::*packetRecerver)(Node*);
	//typedef void (Protocol <Listener_T>::*packetRecerver)(Node*);
	//typedef void (*packetRecerver)(Node*);
protected:
	//Ответы на запросы, при запросе с ответом
	map<IQRespDKey,IQRespD> req_id;

	char read_Buffer[BUFFSIZE];
	int skt_id;
	XML_Parser xml_parser;
	int curDeph;
	Node* curNode;
	Node* curNodeSend;
	void handlerNode();
	void handlNodes(TagHandelrsMapT::iterator begin,TagHandelrsMapT::iterator end);
	void handlIQs(IQHandelrsMapT::iterator begin,IQHandelrsMapT::iterator end, TagIQ &iq);
	void handlerIQ();
	void sendNodeStart(Node &stanza);
	void sendNodeEnd(Node &stanza);
	//Обработка стандартного содержимого  протокола, например iq тега
	//multimap<string,packetRecerver> listeners;
	//list <packetRecerver> listeners;
	TagHandelrsMapT tagHandlers;
	IQHandelrsMapT  iqHandlers;
public:
	Protocol();
	~Protocol();
	//packetRecerver func;
	void parserCreate(int sktID);
	Node* getCurNodeSend(){return curNodeSend;}
	void sendNode(Node &stanza);
	//void addNodeListener(/*packetRecerver func*/);
	void addTagHandler(TagHandler<Node>::PTagHandler handler, string name="", string xmlns="");
	void addIQHandler(TagHandler<TagIQ>::PTagHandler handler, string xmlns="", string name=QUERY_TAG);
	void startParsing(/*int sktID*/);
	virtual void startXMLTagNodeHandler(Node *node);
	virtual void endXMLTagNodeHandler(Node *node);
	//Отправка в сокет не XML содержимого
	void sendString(string data);
	void manadgeIQResp(TagIQ& st);
	//TagIQ sendIQResp(TagIQ& st);
	TagIQ sendIQResp(TagIQ& st, string resultXMLNS, string resultSubTagName);
	//void recevedStanza(Node* stanza){};
	friend void startTag(void *userData,const XML_Char *name, const XML_Char **atts);
	friend void endTag(void *userData,const XML_Char *name);
	friend void characterData (void *userData,const XML_Char *s,int len);
	//virtual void handleTag(Node &tag);
};

#endif /* PROTOCOL_H_ */
